# ------------------------------------------------------------------------
# The following Python code is implemented by Professor Terje Haukaas at
# the University of British Columbia in Vancouver, Canada. It is made
# freely available online at terje.civil.ubc.ca together with notes,
# examples, and additional Python code. Please be cautious when using
# this code; it may contain bugs and comes without warranty of any kind.
# ------------------------------------------------------------------------

from GoldenSectionLineSearchAlgorithm import *
from NewtonLineSearchAlgorithm import *
from BisectionLineSearchAlgorithm import *
from SecantLineSearchAlgorithm import *

# Define the objective function
def F(x):
    return 204165.5 / (330.0 - 2.0 * x) + 10400.0 / (x - 20.0)

# Specify starting and bounding values
lowerBound = 30.0
upperBound = 100.0
startPoint = 30.0

# Set convergence parameters
maxIterations = 100
tolerance = 0.01

# Plot option: negative if no plot, otherwise the plot delay
plot = 0.001

# Run line search algorithms

goldenSectionLineSearch(F, lowerBound, upperBound, maxIterations, tolerance, plot)

newtonLineSearch(F, startPoint, maxIterations, tolerance, plot)

bisectionLineSearch(F, lowerBound, upperBound, maxIterations, tolerance, plot)

secantLineSearch(F, lowerBound, upperBound, maxIterations, tolerance, plot)
