# ------------------------------------------------------------------------
# The following Python code is implemented by Professor Terje Haukaas at
# the University of British Columbia in Vancouver, Canada. It is made
# freely available online at terje.civil.ubc.ca together with notes,
# examples, and additional Python code. Please be cautious when using
# this code; it may contain bugs and comes without warranty of any kind.
# ------------------------------------------------------------------------

import numpy as np

# Game strategy
switchDoor = False

# Number of samples
N = int(1e5)

# Monte Carlo sampling
wins = 0
for i in range(N):

    # Place the car behind one of the doors
    car = np.random.randint(1,4)

    # Let the contestant select a door
    choice = np.random.randint(1,4)

    # Let Monty Hall open one of the other doors
    if choice == car:
        open = np.random.randint(1, 3)
        if choice == 1:
            open = 1 + open
        elif choice == 2:
            if open == 2:
                open = 3
    else:
        taken = [car, choice]
        if 1 not in taken:
            open = 1
        elif 2 not in taken:
            open = 2
        else:
            open = 3

    # Ask contestant to reconsider
    if switchDoor == True:
        taken = [choice, open]
        if 1 not in taken:
            choice = 1
        elif 2 not in taken:
            choice = 2
        else:
            choice = 3

    # Reveal win or loss
    if choice == car:
        wins += 1

# Print the chance of winning
print('\n'"Winning chance: %.2f%%" % (wins/N*100))
