# ------------------------------------------------------------------------
# The following Python code is implemented by Professor Terje Haukaas at
# the University of British Columbia in Vancouver, Canada. It is made
# freely available online at terje.civil.ubc.ca together with notes,
# examples, and additional Python code. Please be cautious when using
# this code; it may contain bugs and comes without warranty of any kind.
# ------------------------------------------------------------------------

import numpy as np

# Import library to plot
import matplotlib.pyplot as plt

# Specify the number of dice and throws
nDice = 10
nThrows = int(1e5)

# Specify the outcomes possible for a single dice
diceOutcomes = np.array([1,2,3,4,5,6])

# Initialize vector to store dice sum for each toss
diceSum = []

# Throw the dice many times
for i in range(nThrows):

    diceSum.append(sum(np.random.choice(diceOutcomes, nDice)))

# Create bins from the lowest to highest possible sum
theBins = np.linspace(nDice, nDice*6, 50)

# Plot the histogram
plt.ion()
plt.hist(diceSum, bins=theBins, edgecolor='red', color='white')
print('\n'"Click somewhere in the plot to continue...")
plt.waitforbuttonpress()
